<template>
	<div>
		<el-dialog title="Edit Post" :visible.sync="postEditFormVisible">
		 	<el-form :model="editForm" enctype="multipart/form-data">
			    <el-form-item label="Post Title" :label-width="formLabelWidth">
			      	<el-input v-model="editForm.title" autocomplete="off">{{ editForm.title }}</el-input>
			    </el-form-item>
			    <el-form-item label="Content" :label-width="formLabelWidth">
			      	<el-input 
			      	type="textarea"
  					:autosize="{ minRows: 2, maxRows: 4}"
			      	v-model="editForm.content" 
			      	autocomplete="off">
			      		{{ editForm.content }}
			      	</el-input>
			    </el-form-item>
		    	<el-form-item label="Category" :label-width="formLabelWidth">
		      		<el-select v-model="editForm.category_id" placeholder="Please select a category">
		        		<el-option
		        			v-for="category in categories"
					      	:key="category.name"
					      	:label="category.name"
					      	:value="category.id"></el-option>
		      		</el-select>
		    	</el-form-item>
		    	<el-form-item>
		    		<input type="file" v-on:change="editImageChange">
		    	</el-form-item>
		  	</el-form>
		  	<span slot="footer" class="dialog-footer">
		    	<el-button @click="postEditFormVisible = false">Cancel</el-button>
		    	<el-button type="primary" @click="updatePost(editForm.id)">Update</el-button>
		  	</span>
		</el-dialog>
		<el-table
			:data="posts"
			style="width: 100%"
			:row-class-name="tableRowClassName"
			v-loading="loading"
			:fit="true">
			<el-table-column
		      type="index"
		      width="50">
		    </el-table-column>
		    <el-table-column
		      label="Title"
		      prop="title"
		      width="200">
		    </el-table-column>
		    <el-table-column
		      label="Content"
		      prop="content"
		      width="300">
		    </el-table-column>
		    <el-table-column
		      label="Published at"
		      prop="updated_at"
		      width="230">
		    </el-table-column>
		    <el-table-column
		      	align="left"
		      	width="280">
		      	<template slot="header" slot-scope="scope">
		        	<el-input
		          	v-model="search"
		          	size="mini"
		          	placeholder="Type to search"/>
		      	</template>
		      	<template slot-scope="scope">
		        	<el-button
		          		size="mini"
		          		type="info"
		          		@click="getPost(scope.row.id)">Edit</el-button>
		        	<el-button
		          		size="mini"
		          		type="danger"
		          		@click="deletePostModal(scope.row.id)">Delete</el-button>
		      	</template>
		    </el-table-column>
		</el-table>
	</div>
</template>

<style>
  	.el-table .warning-row {
    	background: oldlace;
  	}
  	.el-table .success-row {
    	background: #f0f9eb;
  	}
</style>

<script>
  export default {
  		props: [ 'categories' ],
	    data() {
	      	return {
	      		posts: null,
				loading: false,
       			formLabelWidth: '120px',
				labelPosition: 'top',
	      		isCollapse: false,
		        search: '',
		        editForm: {
		        	id: '',
		        	title: '',
		          	content: '',
		          	image: '',
		          	category_id: '',
		        },
		        postEditFormVisible: false,
	      	}
	    },
	    methods: {
            getPosts() {
            	this.loading = true;
				axios.get('/posts')
				.then(response => {
					this.posts = response.data;
				})
				.catch(function (error) {
                    console.log(error);
                });
                this.loading = false;
			},
	    	editImageChange(e){
                console.log(this.editForm.image);
                this.editForm.image = e.target.files[0];
            },
	    	tableRowClassName({row, rowIndex}) {
		        if (rowIndex === 1) {
		          return 'warning-row';
		        } else if (rowIndex === 3) {
		          return 'success-row';
		        }
		        return '';
		    },
			getPost(id) {
				this.postEditFormVisible = true;
                
				axios.get('/posts/' + id +'/edit')
				.then(response => {
					this.editForm.id = response.data.id;
					this.editForm.title = response.data.title;
					this.editForm.content = response.data.content;
					this.editForm.image = response.data.image;
					this.editForm.category_id = response.data.category_id;
				});
			},
			updatePost(id) {
                const config = {
                    headers: { 'content-type': 'multipart/form-data' }
                };

                let formData = new FormData();
                formData.append('_method', 'PATCH');
                formData.append('title', this.editForm.title);
                formData.append('content', this.editForm.content);
                formData.append('category_id', this.editForm.category_id);
                formData.append('image', this.editForm.image);
                
				axios.post('/posts/' + id, formData)
				.then(() => {
		           	this.$message({
		             	type: 'success',
		             	message: 'Changes saved.',
		           	});
		           	this.getPosts();
		           	this.postEditFormVisible = false;
	         	})
			},
			deletePost(id) {
				axios.delete('/posts/' +id)
				.then(response => {
					this.$message({
	                	type: 'error',
	                	message: 'Deleted',
	                });
					this.getPosts();
				})
				.catch (function(error){
					console.log(error);
				})
			},
			deletePostModal(id) {
	            this.$confirm('This will permanently delete the data. Continue?', 'Warning', {
	              	confirmButtonText: 'OK',
	              	cancelButtonText: 'Cancel',
	              	type: 'warning'
	            }).then(() => {
	              	this.$message({
	                	type: 'success',
	                	message: 'Delete completed',
	                	option: this.deletePost(id)
	              	});
	            }).catch(() => {
	              this.$message({
	                type: 'info',
	                message: 'Delete canceled'
	            });          
            	});
          	},
	    },
	    mounted() {
	    	this.getPosts();
	    }
  	}
</script>